PRO Poly_Demo1

winx = 1000
winy =  750

imgx = 477
imgy = 512

elev_dat = Bytarr(imgx, imgy)
Openr, 1, 'boulder_elev.dat'
Readu, 1, elev_dat
Close, 1

landsat = Bytarr(477, 512)
Openr, 1, 'boulder_gray.img'
Readu, 1, landsat
Close, 1

imgx = 120
imgy = 125
elev_dat = Congrid(Float(elev_dat), imgx, imgy, /Interp)
landsat = Bytscl(Congrid(Float(landsat), imgx, imgy, /Interp), Top=127)

zscale = 0.08
viewpoint = [105.0, 70.0, (5.0 * zscale)]
viewvector = [-10.0, -2.5, -0.75]
perspective = 0.06
izoom = 11.0
viewup = [0.0, 1.0]
viewcenter = [0.5, 0.5]
xr = [0, (imgx-1)]
yr = [0, (imgy-1)]
zr = [Min(elev_dat), Max(elev_dat)]
elev_dat = elev_dat * zscale

Set_View3d, viewpoint, viewvector, perspective, izoom, $
            viewup, viewcenter, winx, winy, xr, yr, zr

Print, "Building polygons ..."
Poly_Surf, elev_dat, vertex_list, polygon_list, pg_num

vertex_list = vertex_list
Print, "Normalizing coordinates ..."
vertex_list = Poly_Norm(vertex_list)

Print, "Transforming coordinates ..."
vertex_list = Poly_Trans(vertex_list, !P.T)

Print, "Changing to device coordinates ..."
vertex_list = Poly_Dev(vertex_list, winx, winy)

Window, Xsize=winx, Ysize=winy, Xpos=10, Ypos=50, Colors=128

Print, "Plotting ..."
landsat = Poly_C_Conv(polygon_list, landsat)
Poly_Plot, vertex_list, polygon_list, pg_num, winx, winy, landsat, -1, -1

END
