PRO Sphere_Demo3

sphere1 = Fltarr(3, 6)
sphere1(*, 0) = [ 33.0, -64.0,  0.7]
sphere1(*, 1) = [280.0,   5.0,  1.3]
sphere1(*, 2) = [160.0,  41.0,  2.9]
sphere1(*, 3) = [310.0,  83.0,  0.3]
sphere1(*, 4) = [ 67.0, -16.0,  2.1]
sphere1(*, 5) = [133.0, -75.0,  0.2]

sphere1 = Grid_Sphere(sphere1, 50, 50, /Degrees, Order=0.5)
Poly_Sphere, sphere1, 50, 50, vertex_list1, polygon_list1
pg_num1 = Poly_Count(polygon_list1)
opaque1 = Intarr(pg_num1)
opaque1(*) = 20
f_color1 = Intarr(pg_num1)
f_color1(*) = 60
e_color1 = Intarr(pg_num1)
e_color1(*) = 127

Poly_Sphere, 0.3, 30, 30, vertex_list2, polygon_list2
T3d, /Reset
T3d, Rotate=[0.0, 16.0, 0.0]
T3d, Rotate=[30.0, 0.0, 0.0]
T3d, Translate=[-1.3, 0.2, -0.2]
vertex_list2 = Poly_Trans(vertex_list2, !P.T)
pg_num2 = Poly_Count(polygon_list2)
opaque2 = Intarr(pg_num2)
opaque2(*) = 100
f_color2 = Intarr(pg_num2)
f_color2(*) = 110
e_color2 = Intarr(pg_num2)
e_color2(*) = 0

Poly_Sphere, 0.9, 40, 40, vertex_list3, polygon_list3
T3d, /Reset
T3d, Rotate=[70.0, 0.0, 0.0]
T3d, Translate=[1.0, -0.1, 0.1]
vertex_list3 = Poly_Trans(vertex_list3, !P.T)
pg_num3 = Poly_Count(polygon_list3)
opaque3 = Intarr(pg_num3)
opaque3(*) = 60
f_color3 = Intarr(pg_num3)
f_color3(*) = 70
e_color3 = Intarr(pg_num3)
e_color3(*) = 110

Poly_Sphere, 0.3, 30, 30, vertex_list4, polygon_list4
T3d, /Reset
T3d, Rotate=[0.0, 16.0, 0.0]
T3d, Rotate=[30.0, 0.0, 0.0]
T3d, Translate=[0.6, -0.9, 0.2]
vertex_list4 = Poly_Trans(vertex_list4, !P.T)
pg_num4 = Poly_Count(polygon_list4)
opaque4 = Intarr(pg_num4)
opaque4(*) = 30
f_color4 = Intarr(pg_num4)
f_color4(*) = 90
e_color4 = Intarr(pg_num4)
e_color4(*) = 127

Poly_Merge, vertex_list1, vertex_list2, polygon_list1, polygon_list2, vert, poly, $
            pg_num, fill1=f_color1, fill2=f_color2, edge1=e_color1, edge2=e_color2, $
            opaque1=opaque1, opaque2=opaque2, fill_list=f_color, edge_list=e_color, $
            opaque_list=opaque

Poly_Merge, vert, vertex_list3, poly, polygon_list3, vert1, poly1, $
            pg_num, fill1=f_color, fill2=f_color3, edge1=e_color, edge2=e_color3, $
            opaque1=opaque, opaque2=opaque3, fill_list=f_color1, edge_list=e_color1, $
            opaque_list=opaque1

Poly_Merge, vert1, vertex_list4, poly1, polygon_list4, vert, poly, $
            pg_num, fill1=f_color1, fill2=f_color4, edge1=e_color1, edge2=e_color4, $
            opaque1=opaque1, opaque2=opaque4, fill_list=f_color, edge_list=e_color, $
            opaque_list=opaque

Window, 0, colors=128, Xsize=800, Ysize=600
Loadct, 5
Center_View, xr=[-2.5, 2.5], yr=[-2.5, 2.5], zr=[-2.5, 2.5], ax=(-30.0), az=0.0, zoom=1.5
Set_Shading, Light=[-1.0, 1.0, 1.0]
Tvscl, Polyshade(vert, poly, /T3d)

Window, 1, colors=128, Xsize=800, Ysize=600
vert = Poly_Norm(vert)
vert = Poly_Trans(vert, !P.T)
vert = Poly_Dev(vert, 800, 600)
pg_num = Poly_Count(poly)
Poly_Plot, vert, poly, pg_num, 800, 600, f_color, e_color, opaque

Window, 2, colors=128, Xsize=800, Ysize=600
img = Bytarr(800, 600)
f_color = f_color / 2
Poly_Plot, vert, poly, pg_num, 800, 600, f_color, e_color, opaque, image=img
Tvscl, img

END
