;=====================================================================
;                           PV-WAVE ARL
;
;                 PV-Wave Advanced Rendering Library
;                        11/90   D. Carr
;
;             (c) Copyright Precision Visuals, Inc., 1990
;                     Boulder, Colorado, U.S.A.
;
;                        All Rights Reserved.
;
;  This software is confidential information which is proprietary to
;  and a trade secret of Precision Visuals, Inc. Use, duplication or
;  disclosure is subject to the terms of an appropriate license
;  agreement.
;  ------------------------------------------------------------------
;  Use, duplication, or disclosure by the Government is subject to
;  restrictions set forth in paragraph (b)(3)(B) of the Rights in
;  Technical Data and Computer Software clause in DAR 7-104.9(a).
;
;  Contractor : Precision Visuals, Inc., Boulder, Colorado, U.S.A.
;  -------------------------------------------------------------------
;
;  Program Overview : FUNCTION Poly_Count
;
;  Poly_Count returns the total number of polygons contained in a
;  polygon list.
;
;  MANDATORY INPUTS :
;
;  polygon_list :   An array containing a polygon list.   See the
;                   documentation for the "Polyshade" and "Poly_Plot"
;                   functions for more information about
;                   polygon lists.
;
;=====================================================================
;
FUNCTION Poly_Count, polygon_list

sl = N_Elements(polygon_list)
L1 = Long(1)
poly_pt = 0
pg_num = Long(0)
WHILE (poly_pt LT sl) DO BEGIN
   poly_pt = poly_pt + polygon_list(poly_pt) + L1
   pg_num = pg_num + L1
ENDWHILE

RETURN, pg_num
END
