;=====================================================================
;                           PV-WAVE ARL
;
;                 PV-Wave Advanced Rendering Library
;                        11/90   D. Carr
;
;             (c) Copyright Precision Visuals, Inc., 1990
;                     Boulder, Colorado, U.S.A.
;
;                        All Rights Reserved.
;
;  This software is confidential information which is proprietary to
;  and a trade secret of Precision Visuals, Inc. Use, duplication or
;  disclosure is subject to the terms of an appropriate license
;  agreement.
;  ------------------------------------------------------------------
;  Use, duplication, or disclosure by the Government is subject to
;  restrictions set forth in paragraph (b)(3)(B) of the Rights in
;  Technical Data and Computer Software clause in DAR 7-104.9(a).
;
;  Contractor : Precision Visuals, Inc., Boulder, Colorado, U.S.A.
;  -------------------------------------------------------------------
;
;  Program Overview : FUNCTION Poly_Norm
;
;  Poly_Norm returns a list of 3-D points converted from DATA to
;  NORMAL coordinates.   Poly_Norm uses the system variables !X.S ,
;  !Y.S , and !Z.S to do the conversion.
;
;  SEE ALSO :  Poly_Dev  Poly_Trans
;
;  MANDATORY INPUTS :
;
;  points :         A (3, n) array of points (or verticies) to
;                   transform.
;
;=====================================================================
;
FUNCTION Poly_Norm, points

sz = Size(points)
IF (sz(0) NE 2) THEN BEGIN
   Print, "Invalid points array."
   STOP
ENDIF
IF (sz(1) NE 3) THEN BEGIN
   Print, "Invalid points array."
   STOP
ENDIF

points(0, *) = !X.S(0) + (!X.S(1) * points(0, *))
points(1, *) = !Y.S(0) + (!Y.S(1) * points(1, *))
points(2, *) = !Z.S(0) + (!Z.S(1) * points(2, *))

RETURN, points
END
