PRO m_ps_xyz 
; This program shows 3D gridding with sparse data points.
points = intarr(3, 25)
;
;  Generate grid points
;
points(*, 0) = [0, 0, 0]
points(*, 1) = [5, 0, 0]
points(*, 2) = [10, 0, 0]
points(*, 3) = [15, 0, 0]
points(*, 4) = [20, 0, 0]
;
points(*, 5) = [0, 5, 5]
points(*, 6) = [5, 5, 5]
points(*, 7) = [10, 5, 5]
points(*, 8) = [15, 5, 5]
points(*, 9) = [20, 5, 5]
;
points(*, 10) = [0, 10, 10]
points(*, 11) = [5, 10, 0]  ; dimple here
points(*, 12) = [10, 10, 0] ; dimple here
points(*, 13) = [15, 10, 0] ; dimple here
points(*, 14) = [20, 10, 10]
;
points(*, 15) = [0, 15, 15]
points(*, 16) = [5, 15, 15]
points(*, 17) = [10, 15, 15]
points(*, 18) = [15, 15, 15]
points(*, 19) = [20, 15, 15]
;
points(*, 20) = [0, 20, 20]
points(*, 21) = [5, 20, 20]
points(*, 22) = [10, 20, 20]
points(*, 23) = [15, 20, 20]
points(*, 24) = [20, 20, 20]
;
; Or you can read in the same points as files
;         a.dat  b.dat  and c.dat
;
;openr,1,'x.dat'
;openr,2,'y.dat'
;openr,3,'z.dat' ; or dimple here
;a=fltarr(25)
;b=fltarr(25)
;c=intarr(25)
;readf,1,a
;readf,2,b
;readf,3,c
;
;  But now you have to merge the "a, b, c" arrays
;            into the "points" array	
;for k=0,24 do begin
;points(*,k)=[a(k),b(k),c(k)]
;endfor
;
; Generate the 
zval = intarr(5,5)
zval = GRID_3D(points, 5, 5, Order=0.01, $ 
             XMax=20, XMin=0, YMax=20, YMin=0)
;zval = FAST_GRID3(points, 30, 30, nghb=2, iter=30, $
;               XMax=20, XMin=0, YMax=20, YMin=0)
; Grid the data points.
WINDOW, 1, xsize=456, ysize=356, xpos=670,ypos=35
SURFACE, zval, Bottom=90, Ax=30.0, Az=30.0
wait,5
; create shaded surface plot from uniform grid <<<<<<<<<<<<<<<<<<<<<<<<<<<< 
SHADE_SURF, zval, Ax=30.0, Az=30.0 
;--------------------------- create postscript file for shaded surface plot 
s2=tvrd(0,0,456,356)
set_plot,'ps' 
device,/inches,filename='PS_shade_surf.ps'$ 
      ,scale_factor=0.8,/landscape,bits_per_pixel=8 
tvscl,s2 
device,/close 
set_plot,'x' 
;--------------------------------------------------------------------------
; 
wait,5
SHADE_SURF, zval, Ax=30.0, Az=30.0
wait,5
WINDOW, 2, xsize=356, ysize=356, xpos=770,ypos=430
contour,zval,nlevels=25,background=255,color=0
wait,5
zz=congrid(zval,100,100)
;  create contour plot from uniform grid i<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< 
tvscl,zz 
;---------------------------------- create postscript file for contour plot 
s3=tvrd(0,0,356,356)
set_plot,'ps' 
device,/inches,filename='PS_cont.ps',scale_factor=0.8$ 
      ,/landscape,bits_per_pixel=2 
tvscl,s3 
device,/close 
set_plot,'x' 
;-------------------------------------------------------------------------- 
; 
close,1
close,2
close,3
RETURN
END
